#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


#include "my_message.h"


extern int   id_queue_thr2;



static void            cleaner  (void *p);


void *thr_2 (void *arg)
{
struct MSG       msg;

long int        type = 0;

    pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
    pthread_setcanceltype  (PTHREAD_CANCEL_DEFERRED, NULL);
    pthread_cleanup_push   (cleaner, NULL);


   for (;;)
   {
        msgrcv (id_queue_thr2, &msg, sizeof(msg.header), type, 0);
        if (msg.header.sender == SENDER_THR1)
        {
            printf ("Thread1 sends: value 1 = %d, value2 = %d\n", msg.header.val1, msg.header.val2);
        }
        else
        {
            printf ("error\n");
        }
   }




    pthread_cleanup_pop(0);
    pthread_exit (NULL);
}

static void cleaner (void *p)
{

    printf ("thr_2: Thread end\n");
}



