#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


#include "my_message.h"


extern int   id_queue_thr3;



static void            cleaner  (void *p);

void *thr_1 (void *arg)
{
struct MSG       msg;
struct MSG_THR1 *pMsgThr1;


 

    pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
    pthread_setcanceltype  (PTHREAD_CANCEL_DEFERRED, NULL);
    pthread_cleanup_push   (cleaner, NULL);


    for (;;)
    {
        memset (&msg, 0, sizeof(msg));
        msg.type          = MSG_TYPE;
        msg.header.sender = SENDER_THR1;
        pMsgThr1 = (struct MSG_THR1*)&msg.header.buffer[0];
        pMsgThr1->value1       = 1;
        pMsgThr1->value2       = 2;

        msgsnd (id_queue_thr3, &msg, sizeof (msg.header), 0);
        sleep (3);
    }



    pthread_cleanup_pop(0);
    pthread_exit (NULL);
}

static void cleaner (void *p)
{

    printf ("thr_1: Thread end\n");
}



