#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


#include "my_message.h"


extern int   id_queue_thr3;





static void            cleaner  (void *p);

void *thr_2 (void *arg)
{
struct MSG       msg;
unsigned int     length;
struct MSG_THR2 *pMsgThr2;
const char      *string= "test";
 

    pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
    pthread_setcanceltype  (PTHREAD_CANCEL_DEFERRED, NULL);
    pthread_cleanup_push   (cleaner, NULL);


    for (;;)
    {
        memset (&msg, 0, sizeof(msg));
        msg.type          = MSG_TYPE;
        msg.header.sender = SENDER_THR2;
        length = strlen(string);
        pMsgThr2 = (struct MSG_THR2*)&msg.header.buffer[0];

        if (length >= sizeof (pMsgThr2->buffer))
            length = sizeof (pMsgThr2->buffer) - 1;
        memcpy (&msg.header.buffer[0], string, length);
        msgsnd (id_queue_thr3, &msg, sizeof (msg.header), 0);
        sleep (2);
    }



    pthread_cleanup_pop(0);
    pthread_exit (NULL);
}

static void cleaner (void *p)
{

    printf ("thr_2: Thread end\n");
}



