#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>




extern sem_t s1;
extern sem_t s2;



static void            cleaner  (void *p);


void *thr_2 (void *arg)
{


    pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
    pthread_setcanceltype  (PTHREAD_CANCEL_DEFERRED, NULL);
    pthread_cleanup_push   (cleaner, NULL);


    for (; ; )
    {
        sem_wait (&s1);
        printf ("Thread 2\n");
        sleep(1);
        sem_post (&s2);

    }




    pthread_cleanup_pop(0);
    pthread_exit (NULL);
}

static void cleaner (void *p)
{
    printf ("thr_2: Thread end\n");
}



