#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


#include "my_message.h"


extern int   id_queue_thr3;



static void            cleaner  (void *p);


void *thr_3 (void *arg)
{
struct MSG       msg;
struct MSG_THR1 *pMsgThr1;
struct MSG_THR2 *pMsgThr2;
//int              i;

long int        type = 0;

    pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
    pthread_setcanceltype  (PTHREAD_CANCEL_DEFERRED, NULL);
    pthread_cleanup_push   (cleaner, NULL);


   for (;;)
   {

        msgrcv (id_queue_thr3, &msg, sizeof(msg.header), type, 0);

        /*
        for (i=0; i<16; i++)
            printf ("%d ", msg.header.buffer[i]);
        printf ("\n");
        */
        if (msg.header.sender == SENDER_THR1)
        {
            pMsgThr1 = (struct MSG_THR1*)&msg.header.buffer[0];
            printf ("Thread1 sends: value 1 = %d, value2 = %d\n", pMsgThr1->value1, pMsgThr1->value2);

        }
        else if (msg.header.sender == SENDER_THR2)
        {
            pMsgThr2 = (struct MSG_THR2*)&msg.header.buffer[0];
            printf ("Thread2 sends: string = %s\n", &pMsgThr2->buffer[0]);
        }
   }




    pthread_cleanup_pop(0);
    pthread_exit (NULL);
}

static void cleaner (void *p)
{

    printf ("thr_2: Thread end\n");
}



